
 include \masm32\include\masm32rt.inc

        .data

        align   4

Divisor    dd 10

        .data?

        align   4

Dividend   dd ?
Multiplier dd ?
Shift      dd ?

 .code

_main   PROC

next_divisor:

;find the multiplier and shift count

        xor     eax,eax
        mov     edx,eax
        mov     ebx,Divisor
        inc     edx
        div     ebx
        bsr     eax,eax
        mov     ecx,31
        sub     ecx,eax
        mov     Shift,ecx
        xor     eax,eax
        mov     edx,eax
        inc     edx
        shl     edx,cl
        div     ebx
        mov     Multiplier,eax

next_multiplier_shift:

;test the un-incremented multiplier

        call    MTest

;save the result

        push dword ptr Dividend

;increment the multiplier

        inc dword ptr Multiplier

;test the incremented multiplier

        call    MTest

;recall the un-incremented result and compare

        pop     edx
        mov     eax,Dividend
        mov     ebx,Multiplier
        cmp     eax,edx
        jae     @F

        dec     ebx
        xchg    eax,edx

@@:

;output the result

        push    eax
        push    ebx
        print   chr$('Divisor: ')
        mov     eax,Divisor
        print   str$(eax),32,32
        print   chr$('Multiplier: ')
        pop     eax
        print   uhex$(eax),32,32
        print   chr$('Max Dividend: ')
        pop     eax
        print   uhex$(eax),13,10

        mov     ecx,Shift
        dec     ecx
        mov     Shift,ecx
        mov     eax,Multiplier
        dec     eax
        shr     eax,1
        mov     Multiplier,eax
        dec     eax
        jnz     next_multiplier_shift

        mov     eax,10
        mul dword ptr Divisor
        mov     Divisor,eax
        or      edx,edx
        jz      next_divisor

;if shift count is >=0, shift the multiplier right, then next_multiplier_shift

;if shift count=0 is done, next_divisor

        exit

_main   ENDP

MTest   PROC

; xor eax,eax
; mov Dividend,eax
; ret
        xor     eax,eax
        mov     ebx,eax

MTest0: mov     Dividend,eax
        mul dword ptr Multiplier
        mov     ecx,Shift
        or      ecx,ecx
        js      MTest1

        jz      MTest2

        shr     edx,cl
        jmp short MTest2

MTest1: neg     ecx
        shld    edx,eax,cl

MTest2: push    edx
        mov     edx,ebx
        mov     eax,Dividend
        div dword ptr Divisor
        pop     edx
        cmp     eax,edx
        jnz     MTest3

        mov     eax,Dividend
        inc     eax
        jnz     MTest0

        ret

MTest3: dec dword ptr Dividend
        ret

MTest   ENDP

        END     _main












